/***********************************************************************
 *
 * Copyright (C) 2007-2008 Graeme Gott <graeme@gottcode.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 **********************************************************************/

#ifndef SETTINGS_H
#define SETTINGS_H

#include <QDialog>
#include <QList>
class QCheckBox;
class QComboBox;
class QLabel;
class QListWidget;
class QSpinBox;
class ControlButton;
class Theme;

class Settings : public QDialog
{
	Q_OBJECT
public:
	Settings(QWidget* parent = 0);
	~Settings();

	friend class ControlButton;

public slots:
	virtual void accept();
	virtual void reject();
	void algorithmSelected(int index);
	void themeSelected(const QString& theme);

private:
	void loadSettings();
	void generatePreview();

	QCheckBox* m_gameplay_path;
	QCheckBox* m_gameplay_steps;
	QCheckBox* m_gameplay_time;
	QCheckBox* m_gameplay_smooth;

	QLabel* m_mazes_preview;
	QComboBox* m_mazes_algorithm;
	QSpinBox* m_mazes_targets;
	QSpinBox* m_mazes_size;

	QList<ControlButton*> m_controls;
	ControlButton* m_active_control;

	QListWidget* m_themes_selector;
	QLabel* m_themes_preview;
	Theme* m_theme;
};

#endif // SETTINGS_H
